#!/usr/bin/env python
#encoding=utf-8

import pygame.mixer
import time
import sys
import serial
import threading

VERSION_MAIN = 1
VERSION_SUB  = 0
VERSION_VAR  = 0

argv = sys.argv
argc = len(argv)

# ミキサーの初期化
pygame.mixer.init()
# 音のデータを登録
# bell_x.wavの部分を変更すれば好きな音に変更できます。
bell_sound = [pygame.mixer.Sound("bell_1.wav"), pygame.mixer.Sound("bell_2.wav")]

# シリアルデータを読み込んで音を鳴らす関数
def SerialRead(ser):
	while True:
		line =  ser.readline()			#   一行読み込む
		field = line.strip()			#   改行文字を消す
		field = field.replace("\0", "")	#   ヌル文字を消す

		# 受信したシリアルメッセージの表示
		if len(field) > 0 and line[0] == ':':
			print "\n%s" % field
		else:
			continue

		try:
			lst = map(ord, field[1:].decode('hex')) # HEX文字列を文字列にデコード後、各々 ord() したリストに変換
			csum = sum(lst) & 0xff # チェックサムは 8bit 計算で全部足して　0 なら OK
			lst.pop() # チェックサムをリストから削除
			if csum == 0:		# チェックサムが正しい場合
				if lst[1] == 0x81:	# 相手側の状態通知の場合
					if len(lst) == 23: # すべてのデータがある場合
						DI1 = lst[16] & 0x0F		# デジタル入力を読み込む 
						if DI1 == 0x01:				# DO0がLoの場合
							print "Play Bell1"
							bell_sound[1].play()
						elif DI1 == 0x00:			# DO0がHiの場合
							print "Play Bell0"
							bell_sound[0].play()

					else:
						print "Data Lost"		# データ長が足りないエラー
				else:
					print "Different Packet"	# コマンド番号が違うエラー
			else:
				print "checksum ng"				# チェックサムが違うエラー
		except:
			print "except skip" 				# 上記処理中に例外が起こったときのメッセージ


if __name__ == '__main__':
	print "MONOWIRELESS bell demo Ver." + str(VERSION_MAIN) + "." + str(VERSION_SUB) + "." + str(VERSION_VAR)

	# シリアルポートの初期化
	try:
		#	引数がある場合、引数で指定したデバイスを用いる
		if argc != 2:
			ser = serial.Serial( "/dev/ttyUSB0", 115200, timeout=0.5 );
		else :
			ser = serial.Serial( argv[1], 115200, timeout=0.5 )
	except:
		print "Serial port not found..."
		quit(1)

	# シリアルを読み込むスレッドの初期化
	t = threading.Thread( target=SerialRead, args=(ser,) )
	t.setDaemon(True)
	t.start()

	#	q を入力すると終了
	while True:
		key = raw_input()
		if key == "q":
			break

	ser.close()
